if(!dojo._hasResource["com.ibm.mashups.builder.Api"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.Api"] = true;
/**
 * Please note, the following builder JavaScript API are not public in Lotus Mashups v1.1.
 * The APIs are not stable and subject to change before they go public in v2.
 */
dojo.provide("com.ibm.mashups.builder.Api");

dojo.require("com.ibm.mm.catalog.CatalogPane");

com.ibm.mashups.builder.builderTopicHandlers = null;

com.ibm.mashups.builder.createLMDialog = function(contentDiv, params){
    return new com.ibm.mm.builder.widget.CustomDialog(params, contentDiv);
};

com.ibm.mashups.builder.displayLMDialog = function(contentDiv, params){
    var dlg = com.ibm.mashups.builder.createLMDialog(contentDiv, params);
    dlg.show();	
    return dlg;
};

/**
 * when user wants to open the widget configuration mode,
 * this method should be called to create the widget config dialog and switch to edit mode
 * @param {String} widgetId widget instance id 
 */
com.ibm.mashups.builder.showWidgetConfigDialog=function(widgetId){
	var menu = new com.ibm.mm.builder.widget.WidgetMenu({
		iwidgetId: widgetId
	});
	menu.showEditPane();
};

/**
 * when user finishes configuring the widget and clicks the save button,
 * this method should be called to close the widget config dialog and switch to view mode
 * @param {String} widgetId widget instance id 
 */
com.ibm.mashups.builder.closeWidgetConfigDialog=function(widgetId){
	dojo.publish(com.ibm.mm.builder.eventTopics.Widget_ConfigurationFinished, [widgetId]);
};

/**
 * in case production widget need to subscribe the topic published from builder framework.
 * @param {String} topicName
 * @param {Object} obj
 * @param {Object} callback
 */
com.ibm.mashups.builder.subscribeBuilderTopics = function(topicName,obj,callback){
	var oneHandler = dojo.subscribe(topicName, obj, callback);
	if (!com.ibm.mashups.builder.builderTopicHandlers){
		com.ibm.mashups.builder.builderTopicHandlers = [];
	}
	com.ibm.mashups.builder.builderTopicHandlers.push(oneHandler);
};

/**
 * builder api to unsubscribe all the topic handlers
 */	
com.ibm.mashups.builder.clearBuilderTopicHandlers = function(){
	dojo.forEach(com.ibm.mashups.builder.builderTopicHandlers, dojo.unsubscribe);
	com.ibm.mashups.builder.builderTopicHandlers = [];	
};

}
