if(!dojo._hasResource["com.ibm.mashups.builder.model.Theme"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.Theme"] = true;
dojo.provide("com.ibm.mashups.builder.model.Theme" );

/**
 * This interface defines builder runtime theme operation.
 * Usage: var theme = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
 * @ibm-module Builder
 */
dojo.declare( "com.ibm.mashups.builder.model.Theme", null, {

    /**
     * Returns builder runtime theme id
     * @ibm-api
     * @type    String
     * @return  runtime theme id, never <code>null</code>
     */
    getID:function(){
    	return "";
    },

    /**
     * Set builder runtime theme id
     * @param {String} _themeId theme id to set, must not be <code>null</code>. 
     * @ibm-spi
     * @type void
     */
    setID:function(_themeId){
    },
    
    /**
     * Register the layout widget id in theme model
     * @param {String} _layoutId layout widget id in theme.html
     * @ibm-spi
     * @deprecated not used
     * @type void
     */
    registerLayout:function(_layoutId){
    },
    
    /**
     * Return array which contains all layout widgets' id in current theme.
     * @ibm-api
     * @type String[]
     * @deprecated Use enabler layout model API to get the component container instead, some sample code:
	 * var navigationModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
     * var layoutModel = navigationModel.getLayoutModel(pageId);
     * var root = layoutModel.getRoot().start();
     * var children = layoutModel.getChildren(root);
     * while(children.hasNext()) {
     *   var child = children.next();
     *   // check the child.getLayoutNodeType() result and see whether it is a LayoutContainer
     * }
     * @return null
     */
    getLayouts:function(){
    }
    
});

}
