if(!dojo._hasResource["com.ibm.mm.builder.dnd.IndicatorSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.IndicatorSource"] = true;
dojo.provide("com.ibm.mm.builder.dnd.IndicatorSource");

dojo.require("dojo.dnd.Source");

/**
 * IndicatorSource is the auto sync source. It will create indicator during dragging.
 * 
 * @author jarod (zhangpy@cn.ibm.com)
 */
dojo.declare("com.ibm.mm.builder.dnd.IndicatorSource", dojo.dnd.AutoSource, {
		
	onMouseMove: function(e){
		this.inherited(arguments);
		if (this.isDragging) {
			if (this.removeIndicatorTimer) {
				clearTimeout(this.removeIndicatorTimer);
			}
			if (dojo.dnd.manager().canDropFlag && this.targetState != "Disabled") {
				this.createIndicator(e);
			}
		}
	},
	
	onDndDrop: function(source, nodes, copy, target){
		this.inherited(arguments);
		this.removeIndicator();
	},

	removeIndicator: function(){
		//callback for customized layout to remove inidcator
	},
	
	createIndicator: function(e){
		//callback for customized layout to create inidcator
	},
	
	onDndCancel: function(){
		this.inherited(arguments);
		this.removeIndicator();
	},
	
	onDraggingOut: function(){
		this.removeIndicatorTimer = setTimeout(dojo.hitch(this, function(){
			this.removeIndicator();
		}, 2));
	}
});

}
