// This is Change Layout
dojo.provide("com.ibm.pb.customize.ChangeLayoutPaletteContainer");

dojo.require("com.ibm.pb.customize.LotusPaletteContainer");

dojo.declare("com.ibm.pb.customize.ChangeLayoutPaletteContainer",
	[com.ibm.pb.customize.LotusPaletteContainer],
	{
		numRows: 3,			// the number of rows of results to be displayed
		columnHash:{},		// an associative array of layout id to number of columns
		
		constructor: function() {
			this.label = this.nlsBundle["change_layout_browseLayouts"];
			this.tabLabel = this.nlsBundle["change_layout_launchLabel2"];
		},
		
		postCreate: function(){
			this.inherited("postCreate",arguments);
			
			// change the size of the item results by adding a css class
			dojo.addClass(this.domNode,"lotusLargeWidgets hasLotusMessage");
			
			// add a message to the UI that says the layout will not change until the page is saved
			var msgNode = this.createLotusMsgNode(this.nlsBundle.change_layout_save_warning,"Warning");
			this.center.appendChild(msgNode);
			
			// when the apply function from the Customize Controller API is executed, change the visually selected item
			this.connect(this, "apply", "changeSelection");
		},
		
		changeSelection: function(/*object*/args){
			// summary: called when apply is called
			// args: contains args.id which is the newly selected item
			this.changeSelected(args.id);
		}
});
