dojo.provide("com.ibm.pb.layout.filters.ColumnContainerStyleFilter");
dojo.require("com.ibm.pb.layout.filters.ContainerStyleFilter");
dojo.declare("com.ibm.pb.layout.filters.ColumnContainerStyleFilter", [com.ibm.pb.layout.filters.ContainerStyleFilter], {
	// corresponds to a column container type
	
    _filterStyle: function(layoutNode, node, oldStyle, newStyle) {
		if (this._isControl(layoutNode)) {
			// resize widget
			// widgets in columns cannot change width, it should be fluid
			if (newStyle.width){
				delete newStyle.width;
			}
			// make sure the widget is not too tall
			if (parseInt(newStyle.height) > this.widgetMaxHeight) {
				newStyle.height = this.widgetMaxHeight + "px";
			}
			// make sure the widget is not too short
			if (parseInt(newStyle.height) < this.widgetMinHeight) {
				newStyle.height = this.widgetMinHeight + "px";
			}
		} else if (this._isContainer(layoutNode)) {
			// resizer container
			if(parseInt(newStyle.width) < this.containerMinWidth){
				newStyle.width = this.containerMinWidth+"%";
			}
		}
	},
	_isAgree: function(layoutNode, node, oldStyle, newStyle) {
		// summary: return true if the new style is allowed, false otherwise
		if (this._isContainer(layoutNode)) {
			if(parseInt(newStyle.width) < this.containerMinWidth){
				return false;
			}
		}
		return true;
	}
});
