/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.Iterator");

/**
 * Extended iterator interface, which allows iterating over elements
 * in a sequentiell order. It allows to set the starting point of the
 * iteration and exposes the number of elements in the iteration.
 *
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.Iterator", null, {

    /**
     * Returns <tt>true</tt> if the iteration has more elements.
     * @return  {Boolean} <tt>true</tt> if the iterator has more elements,
     *          otherwise <tt>false</tt>.
     */
    hasNext: function(){
    },
    
    /**
     * Returns the next element in the iteration.  Calling this method
     * repeatedly until the hasNext() method returns false will return
     * each element in the underlying collection exactly once.
     * The cursor position is increased by one. if no element is available
     * at the specified position, <code>null</code> is returned and the
     * position is not changed
     *
     * @returns {Object} the next element in the iteration
     */
    next: function(){
    },
    
    /**
     * Returns the number of elements in this iterator.
     *
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The
     *          return value when executed through the deferred object
     *          is the number of elements in this iterator
     */
    size: function(){
    },
    
    /**
     * Sets the zero-based position of the cursor, i.e the last
     * element is addressed through size()-1.
     * A position which is out of the bounds of the current iteration
     * is ignored and in this case the position is set to the nearest
     * possible value within valid bounds.
     *
     * @param {int} position    position of the cursor. Defaults to zero
     * @type void
     */
    setCursorPosition: function(position){
    },
    
    /**
     * Returns the zero-based position of the cursor, i.e. zero for the first element
     *
     * @return {int} the position of the cursor
     */
    getCursorPosition: function(){
    }
});
